import { Component, createEffect, createResource, For } from 'solid-js';

import OlMap from 'ol/Map';

import dispatch from '../../workers/dispatcher-main';
import Gpx from '../gpx';

interface Props {
  map: () => OlMap | null;
}

const [allGpxIds, { refetch }] = createResource(
  async () =>
    await dispatch({
      action: 'getAllGpxes',
      params: {},
    })
);

export const AllGpxes: Component<Props> = ({ map }) => {
  createEffect(() => {
    console.log({ caller: 'AllGpxes', allGpxes: allGpxIds(), map: map() });
  });

  return (
    // @ts-ignore
    <For each={allGpxIds()}>
      {(gpxId: string) => {
        console.log({ caller: 'AllGpxes / loop', gpxId });
        return <Gpx map={map} gpxId={gpxId} />;
      }}
    </For>
  );
};

export default AllGpxes;
export { refetch };
