/// <reference lib="webworker" />
import { initDb } from '../db';
import {
  putNewGpx,
  existsGpx,
  pruneAndSaveImportedGpx,
  getGpxesForViewport,
  getGpx,
  getAllGpxes,
} from '../db/gpx';
import { getTrk, putNewTrk } from '../db/trk';
import { getTrkseg } from '../db/trkseg';

//const self = globalThis as unknown as WorkerGlobalScope;

const actions = {
  initDb,
  putNewGpx,
  putNewTrk,
  existsGpx,
  pruneAndSaveImportedGpx,
  getAllGpxes,
  getGpxesForViewport,
  getGpx,
  getTrk,
  getTrkseg,
};

console.log({ caller: 'dispatcher-worker', actions });

onmessage = async function (e) {
  console.log({ caller: 'dispatcher-worker / onmessage', e });
  const { id, payload } = e.data;
  var returnValue: any = 'unknownAction';
  if (payload.action in actions) {
    console.log({ caller: 'dispatcher-worker / awaiting', id, payload });
    returnValue = await actions[<keyof typeof actions>payload.action](
      payload.params
    );
  }
  postMessage({ id: id, payload: returnValue });
  console.log({ caller: 'dispatcher-worker / response sent', id, returnValue });
};

//export default self;
